package com.jesusbianco;

import javax.sql.DataSource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;

public class Utilities implements APIsErrorCodes {

	public static final Logger logger = LoggerFactory.getLogger(Utilities.class);

	public static HikariDataSource ds = null;	

	public static DataSource getMySQLDataSourceConnectionPool() {

		HikariConfig config = new HikariConfig();

		String driverClassName = Configurator.MYSQL_DRIVER_CLASS_NAME;
		String url = Configurator.MYSQL_CONNECTION_STRING;
		String user = Configurator.MYSQL_USERNAME;
		String password = Configurator.MYSQL_PASSWORD;

		config.setDriverClassName(driverClassName);
		config.setJdbcUrl(url);
		config.setUsername(user);
		config.setPassword(password);
		config.setMaximumPoolSize(3);

		config.setConnectionTimeout( 10000 );		//	 10 seconds
		config.setMaxLifetime( 600000 );			//	600 seconds = 10 minutes

		config.addDataSourceProperty("cachePrepStmts", "true");
		config.addDataSourceProperty("prepStmtCacheSize", "250");
		config.addDataSourceProperty("prepStmtCacheSqlLimit", "2048");

		if (ds == null) {
			ds = new HikariDataSource(config);
		}

		return ds;

	}

}

